<?php
define('DB_HOST', '127.0.0.1');
define('DB_PORT', 3306);
define('DB_USER', 'root');
define('DB_PASSOWRD', '111111');
define('DB_NAME', 'baoguan');
define('DB_PREFIX', '');

class db{

	static function is_table($sql){
		return preg_match('#^[\w\.]+$#', $sql);
	}

	static function tbl_name($name){
		return (DB_PREFIX == '' || preg_match('/^'.DB_PREFIX.'/', $name) || strpos($name, '.') !== false) ? $name : DB_PREFIX.$name;
	}

	static function parse_where($where){
		if(is_int($where) || (is_string($where) && preg_match('/^(-)?\d+$/', $where))){
			$where = 'id='.intval($where).' ';
		}
		return $where;
	}

	static function exists($table, $where = 1){
		return self::count($table, $where) > 0;
	}

	static function count($table, $where = 1){
		if($table == ''){
			return 0;
		}
		$d = self::query('SELECT count(*) cnt FROM '.self::tbl_name($table).' WHERE '.$where.' LIMIT 1');
		return $d[0]['cnt'];
	}

	static function find($field, $table, $where = ''){
		$data = self::select($table, $where);
		return isset($data[$field]) ? $data[$field] : '';
	}

	static function select($sql, $where = '', $order = ''){
		if(self::is_table($sql)){
			$sql = 'select * from '.self::tbl_name($sql).($where ? ' where '.self::parse_where($where) : '').($order ? ' order by '.$order : '');
		}
		$data = self::query($sql.' limit 1');
		return !empty($data[0]) ? $data[0] : null;
	}

	static function all($sql, $where = '', $order = ''){
		if(self::is_table($sql)){
			$sql = 'select * from '.self::tbl_name($sql).($where ? ' where '.self::parse_where($where) : '').($order ? ' order by '.$order : '');
		}
		return self::query($sql);
	}

	private static function query($sql, $escape = 0, $val = ''){
		static $link = null;
		if(empty($link)){
			$link = mysqli_connect(DB_HOST, DB_USER, DB_PASSOWRD, DB_NAME, defined('DB_PORT') && DB_PORT ? DB_PORT : 3306);
			if(!$link){
				fatal_error('Mysql connect error!');
			}
			if(mysqli_get_server_info($link) > '5.0.1'){
				mysqli_query($link, "SET sql_mode=''");
			}
			mysqli_query($link, 'SET NAMES utf8');
		}
		if($escape){
			return mysqli_real_escape_string($link, $val);
		}
		$sql = trim($sql);
		if(defined('TRACE_SQL')){
			logd('SQL: '.str_replace("\r\n", '', $sql));
		}
		if(preg_match('/^select/i', $sql)){
			$result = mysqli_query($link, $sql);
			if(mysqli_errno($link)){
				fatal_error('Mysql error:'.mysqli_error($link).' <br/><b>SQL</b>: '.$sql, 1);
			}
			$r = array();
			if($result){
				while($data = $result->fetch_assoc()){
					$r[] = $data;
				}
			}else{
				$r = NULL;
			}
			return $r;
		}else if(preg_match('/^(insert|replace|update|delete)/i', $sql)){
			mysqli_query($link, $sql);
			if(mysqli_errno($link)){
				fatal_error('Mysql error:'.mysqli_error($link).'<br/><b>SQL</b>:'.$sql, 1);
			}
			if(preg_match('/^insert/i', $sql)){
				return mysqli_insert_id($link);
			}else{
				return mysqli_affected_rows($link);
			}
		}else{
			return NULL;
		}
	}
}